Language.Haskell.Syntax

# Modules

data HsModule
data HsExportSpec
data HsImportDecl
data HsImportSpec
data HsAssoc

# Declarations

data HsDecl
data HsConDecl
data HsBangType
data HsMatch
data HsRhs
data HsGuardedRhs
data HsSafety

# Class Assertions and Contexts

data HsQualType
type HsContext
type HsAsst

# Types

data HsType

# Expressions

data HsExp
data HsStmt
data HsFieldUpdate
data HsAlt
data HsGuardedAlts
data HsGuardedAlt

# Patterns

data HsPat
data HsPatField

# Literals

data HsLiteral

# Variables, Constructors and Operators

data Module
data HsQName
data HsName
data HsQOp
data HsOp
data HsSpecialCon
data HsCName

# Builtin names

## Modules

prelude_mod
main_mod

## Main function of a program

main_name

## Constructors

unit_con_name
tuple_con_name
list_cons_name
unit_con
tuple_con

## Type constructors

unit_tycon_name
fun_tycon_name
list_tycon_name
tuple_tycon_name
unit_tycon
fun_tycon
list_tycon
tuple_tycon

# Source coordinates

data SrcLoc